﻿using Cosmos.Core.Memory;
using Cosmos.System.Graphics;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using Sys = Cosmos.System;

namespace vbeTest
{
	public class Kernel : Sys.Kernel
	{
		uint ScreenSizeX = 1024;
		uint ScreenSizeY = 768;
		public static Canvas MainCanvas;
		public static Bitmap bitmap;
		protected override void BeforeRun()
		{
			MainCanvas = new VBECanvas(new Mode(ScreenSizeX, ScreenSizeY, Cosmos.System.Graphics.ColorDepth.ColorDepth32));
			//MainCanvas = new SVGAIICanvas(new Mode(ScreenSizeX, ScreenSizeY, Cosmos.System.Graphics.ColorDepth.ColorDepth32));
			MainCanvas.DrawFilledRectangle(Color.White, 0, 0, (int)ScreenSizeX, (int)ScreenSizeY);
			MainCanvas.DrawFilledRectangle(Color.DarkCyan, 0, 0, 100, 100);
			bitmap = GetImage(0, 0, 100, 100);
		}
		public static Bitmap GetImage(int X, int Y, int SizeX, int SizeY)
		{
			Bitmap bitmap = new Bitmap((uint)SizeX, (uint)SizeY, ColorDepth.ColorDepth32);
			for (int y = Y, destY = 0; y < Y + SizeY; y++, destY++)
				for (int x = X, destX = 0; x < X + SizeX; x++, destX++)
					bitmap.RawData[destY * SizeX + destX] = MainCanvas.GetPointColor(x, y).ToArgb();
			return bitmap;
		}
		protected override void Run()
		{
			MainCanvas.DrawFilledRectangle(Color.White, 0, 0, (int)ScreenSizeX, (int)ScreenSizeY);
			for (int i = 0; i < 10; i++)
			{
				MainCanvas.DrawImage(bitmap, i * 100, 200);
				MainCanvas.DrawImage(bitmap, 200, i * 100);
			}
			MainCanvas.Display();
			Heap.Collect();
		}
	}
}
